
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《编译与反编译技术》—第1章1.7节C语言程序的编译流程 / iVAN</title>

    <meta name="description" content="《编译与反编译技术》—第1章1.7节C语言程序的编译流程 本节书摘来自华章出版社&lt;编译与反编译技术&gt;一书中的第1章,第1.7节C语言程序的编译流程,作者庞建民,陶红伟,刘晓楠,岳峰,更多章节内容可以访问&quot;华章计算机&quot;公众号查看. 1.7 C语言程序的编译流程 本节以C语言程序的编译流程为例,介绍实际的C语言编译器是如何运作的.通常把整个代码的编译流程分为编译过程和链接过程. 1.编译过程 编译过程可分为编译预处理.编译与优化.汇编等阶段. (1)编译预处理 编译预处理即读取C源程序,对其中的伪指令(以#开头的指令)和特殊 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《编译与反编译技术》—第1章1.7节C语言程序的编译流程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本节书摘来自华章出版社《编译与反编译技术》一书中的第1章，第1.7节C语言程序的编译流程，作者庞建民，陶红伟，刘晓楠，岳峰，更多章节内容可以访问“华章计算机”公众号查看。</p>
<p><b>1.7</b><b>　</b><b>C</b><b>语言程序的编译流程</b></p>
<p>本节以C语言程序的编译流程为例，介绍实际的C语言编译器是如何运作的。通常把整个代码的编译流程分为编译过程和链接过程。</p>
<p><b>1.</b><b>编译过程</b></p>
<p>编译过程可分为编译预处理、编译与优化、汇编等阶段。</p>
<p>（1）编译预处理</p>
<p>编译预处理即读取C源程序，对其中的伪指令（以#开头的指令）和特殊符号进行处理。主要包括以下几个方面：</p>
<p>1）宏定义指令，如# define Name TokenString、# undef等。对于前一个伪指令，预编译所要做的是将程序中的所有Name用TokenString替换，但作为字符串常量的Name则不被替换。对于后一个伪指令，则将取消对某个宏的定义，使以后该串的出现不再被替换。</p>
<p>2）条件编译指令，如# ifdef、# ifndef、# else、# elif、# endif等。这些伪指令的引入使得程序员可以通过定义不同的宏来决定编译程序对哪些代码进行处理。预编译程序将根据有关的文件，将那些不必要的代码过滤掉。</p>
<p>3）头文件包含指令，如# include "FileName"或者# include &lt;FileName&gt;等。在头文件中一般用伪指令# define定义了大量的宏，还有对各种外部符号的声明。采用头文件的目的是使某些定义可以供多个不同的C源程序使用。因为在需要用到这些定义的C源程序中，只需加上一条# include语句，而不必再在此文件中将这些定义重复一遍。预编译程序将把头文件中的定义统统都加入它所产生的输出文件中，以供编译程序对之进行处理。注意，这个过程是递归进行的，也就是说，被包含的文件可能还包含其他文件。包含到C源程序中的头文件可以是系统提供的，这些头文件一般放在/usr/include目录下，在# include中使用它们要用尖括号（&lt;  &gt;）。另外开发人员也可以定义自己的头文件，这些文件一般与C源程序放在同一目录下，此时在# include中要用双引号（" "）。</p>
<p>4）特殊符号。例如在源程序中出现的LINE标识将被解释为当前行号（十进制数），FILE则被解释为当前被编译的C源程序的名称。预编译程序对于在源程序中出现的这些串将用合适的值进行替换。预编译程序所完成的基本上是对源程序的“替代”工作。经过此种替代，生成一个没有宏定义、没有条件编译指令、没有特殊符号的输出文件。这个文件的含义与没有经过预处理的源文件是相同的，但内容有所不同。下一步，此输出文件将作为编译程序的输入而被翻译成为机器指令序列。</p>
<p>5）删除注释。删除所有的注释“//…”和“/*…*/”。</p>
<p>6）保留所有的#pragma编译器指令。以#pragma开始的编译器指令必须保留，因为编译器需要使用它们。</p>
<p>经过预编译后的.i文件不包含任何宏定义，因为所有的宏已经被展开，并且包含的文件也已经被插入.i文件中。所以，当无法判断宏定义是否正确或头文件包含是否正确时，可以查看预编译后的文件来确定。</p>
<p>（2）编译与优化</p>
<p>经过预编译得到的输出文件中只有常量、变量的定义，以及C语言的关键字，如main、if、else、for、while、{、}、+、-、*、\等。编译程序所要做的工作就是通过词法分析和语法分析，在确认所有的指令都符合语法规则之后，将其翻译成等价的中间代码表示或汇编代码。优化处理涉及的问题不仅同编译技术本身有关，而且同机器的硬件环境也有关。优化中的一种是对中间代码的优化。另一种优化则主要是针对目标代码的生成而进行的。对于前一种优化，主要的工作是删除公共表达式、循环优化（代码外提、强度削弱、变换循环控制条件、已知量的合并等）、复写传播，以及无用赋值的删除等。后一种类型的优化同机器的硬件结构密切相关，最主要的是考虑如何充分利用机器的各个硬件寄存器存放有关变量的值，以减少对内存的访问次数。另外，如何根据机器硬件执行指令的特点（如流水线、RISC、CISC、VLIW等）而对指令进行一些调整使目标代码比较短，执行的效率比较高，也是优化的一个重要任务。经过优化得到的汇编代码序列必须经过汇编程序的汇编转换成相应的机器指令序列，方能被机器执行。</p>
<p>（3）汇编</p>
<p>汇编过程是把汇编语言代码翻译成目标机器指令的过程。对于待编译处理的每一个C语言源程序，都将经过这一处理过程而得到相应的目标文件。目标文件中所存放的也就是与源程序等效的机器语言代码。目标文件由段组成，通常一个目标文件中至少有两个段：①代码段。该段中所包含的主要是程序的机器指令，一般是可读和可执行的，但却不可写。②数据段。主要存放程序中要用到的各种全局变量或静态的数据，一般是可读、可写、可执行的。</p>
<p>UNIX环境下主要有三种类型的目标文件：①可重定位文件，其中包含适合于其他目标文件链接以创建一个可执行的或者共享的目标文件的代码和数据。②共享的目标文件，这种文件存放了适合于在两种上下文里链接的代码和数据。第一种是静态链接程序，可把它与其他可重定位文件共享的目标文件一起处理来创建另一个目标文件；第二种是动态链接程序，将它与另一个可执行文件及其他共享目标文件结合到一起，创建一个进程映像。③可执行文件，它包含了一个可以被操作系统通过创建一个进程来执行的文件。汇编程序生成的实际上是第一种类型的目标文件。对于后两种还需要其他的一些处理方能得到，这就是链接程序的工作了。</p>
<p><b>2.</b><b>链接过程</b></p>
<p>由汇编程序生成的目标文件并不能立即被执行，其中可能还有许多没有解决的问题。例如，某个源文件中的函数可能引用了另一个源文件中定义的某个符号（如变量或者函数调用等）；在程序中可能调用了某个库文件中的函数，等等。所有的这些问题，都需要经过链接程序的处理方能得以解决。链接程序的主要工作就是将有关的目标文件彼此相连接，亦即将在一个文件中引用的符号同该符号在另外一个文件中的定义连接起来，使得所有的这些目标文件成为一个能够被操作系统装入执行的统一整体。根据开发人员指定的与库函数的链接方式的不同，链接处理通常可分为两种：①静态链接。在该方式下，函数的代码将从其所在的静态链接库中被复制到可执行程序中。这样当该程序被执行时，这些代码将被装入该进程的虚拟地址空间中。静态链接库实际上是一个目标文件的集合，其中的每个文件含有库中的一个或者一组相关函数的代码。②动态链接。在该方式下，函数的代码被放到称作动态链接库或共享对象的某个目标文件中。链接程序此时所做的只是在最终的可执行程序中记录下共享对象的名字以及一些少量的登记信息。在该可执行文件被执行时，动态链接库的全部内容将被映射到运行时相应进程的虚地址空间。动态链接程序将根据可执行程序中记录的信息找到相应的函数代码。对于可执行文件中的函数调用，可分别采用动态链接或静态链接的方法。使用动态链接能够使最终的可执行文件比较短小，并且当共享对象被多个进程使用时能节约一些内存，因为在内存中只需要保存一份此共享对象的代码。但并不是使用动态链接就一定比使用静态链接要优越，在某些情况下动态链接可能带来一些性能上的</p>
<p>损失。</p>
<p><b>3. GCC</b><b>的编译链接</b></p>
<p>在Linux中使用的GCC编译器是把以上几个过程进行了捆绑，使用户只使用一次命令就完成编译工作，这确实很方便，但对于初学者了解编译过程却很不利。GCC代理的编译流程如下：①预编译，将.c文件转化成.i文件，使用的GCC命令是gcc –E （对应于预处理命令cpp）；②编译，将.c/.h文件转换成.s文件，使用的gcc命令是gcc –S（对应于编译命令cc1，实际上，现在版本的GCC使用cc1将预编译和编译两个步骤合成为一个步骤；③汇编，将.s文件转化成.o文件，使用的GCC命令是gcc –c （对应于汇编命令as）；④链接，将.o文件转化成可执行程序，使用的GCC命令是gcc（对应于链接命令ld）。</p>
<p>以名为hello.c的程序为例，编译流程主要经历如图1-2所示的四个过程。</p>
<p> </p>
<p>图1-2　C语言程序编译流程图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzdiMzkxY2I2ZjVlMjc5OTViNzU2ZDc5MmQwNTU2MDM2Y2IyODUzZDAuanBlZw==.jpg"></p>
<p>例如，hello.c为：</p>
<p>#include<br />
&lt;stdio.h&gt;</p>
<p>Int<br />
main(int argc，char *argv[])</p>
<p>{</p>
<p>    printf("hello world\n");</p>
<p>    return 0;</p>
<p>}</p>
<p>运行gcc –S hello.c可以得到hello.s文件，其内容为：</p>
<p>.file<br />
"hello.c"</p>
<p>.def  ___main; .scl <br />
2; .type 32; .endef</p>
<p>.section  .rdata，"dr"</p>
<p>LC0:</p>
<p>.ascii<br />
"hello world\0"</p>
<p>.text</p>
<p>.globl<br />
_main</p>
<p>.def<br />
_main; .scl  2; .type 32; .endef</p>
<p>_main: </p>
<p>LFB6: </p>
<p>.cfi_startproc </p>
<p>pushl   %ebp </p>
<p>.cfi_def_cfa_offset<br />
8</p>
<p>  ...</p>
<p>所有以字符“.”开头的行都是指导汇编器和链接器的命令，其他行则是被翻译成汇编语言的代码。</p>
<p>C语言编译的整个过程是比较复杂的，涉及的编译器知识、硬件知识、工具链知识非常多。一般情况下，只需要知道其分成编译和链接两个阶段，编译阶段是将源程序（*.c)转换成为目标代码（一般是obj文件），链接阶段是将源程序转换成的目标代码（obj文件）与程序里面调用的库函数对应的代码链接起来形成对应的可执行文件（exe文件），其他的都需要在实践中多多体会才能有更加深入的理解。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 07:37:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《编译与反编译技术》—第1章1.7节C语言程序的编译流程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6ZVaWM.html" rel="bookmark">c语言-C语言程序，编译没错，但执行完之后就提示错误。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C语言程序,编译没错,但执行完之后就提示错误. #include #include #include struct st { char name[50]; int age; }info; void main(void) { struct st s[20]; char FileA[50]; FILE*fp; if((fp=fopen(&quot;e:students.txt&quot;,&quot;wt&quot;))=NULL) { printf(&quot;打开过程中有错,请检查n&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvJmr8M.html" rel="bookmark">《Nmap渗透测试指南》&mdash;第1章1&period;3节Linux&sol;Unix源码编译安装Nmap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 Linux/Unix源码编译安装Nmap在Linux/Unix中我们可以很方便地通过源码编译安装Nmap,首先在&quot;http://nmap.org/ download.html&quot;中选择源码进行下载.下载完毕后首先解压压缩包. root@ubuntu:/home# bzip2 -cd nmap-6.46.tar.bz2 | tar xvf - nmap-6.46/zenmap/zenmapCore/I18N.py nmap-6.46/zenmap/zenmapCore/Versio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwR36M.html" rel="bookmark">《趣题学算法》&mdash;第0章0&period;7节算法的程序实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0.7 算法的程序实现 有了解决问题的正确算法,就可以利用一种计算机程序设计语言将算法实现为可在计算机上运行的程序.本书选用业界使用最广泛.最成熟的C++语言来实现解决每一个问题的算法.C++语言是面向对象的程序设计语言,它为程序员提供了一个庞大的标准库.有趣的是,C++脱胎于C语言.所以,读者若具有C语言某种程度的训练,对于理解本书提供的C++代码一定是大有裨益的.闲话少说,让我们先来一睹C++语言程序的&quot;芳容&quot;吧. 解决问题0-1&quot;计算逆序数&quot;的C++程序如下.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdWkl3M.html" rel="bookmark">《编程珠玑（第2版&bull;修订版）》&mdash;第2章2&period;8节变位词程序的实现（边栏）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.8 变位词程序的实现(边栏)⑪ 我的变位词程序按三个阶段的&quot;管道&quot;组织,其中一个程序的输出文件作为下一个程序的输入文件.第一个程序标识单词,第二个程序排序标识后的文件,而第三个程序将这些单词压缩为每个变位词类一行的形式.下面是一个仅有6个单词的字典的处理过程. 输出包括三个变位词类. 下面的C语言sign程序假定没有超过100个字母的单词,并且输入文件仅包含小写字母和换行符.(因此我使用了一个一行的命令对字典进行预处理,将其中的大写字母改为小写字母.) int charcomp(c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOmG18M.html" rel="bookmark">《黑客秘笈&mdash;&mdash;渗透测试实用指南》&mdash;第2章2&period;4节Web应用程序的扫描</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 Web应用程序的扫描 黑客秘笈--渗透测试实用指南 网络扫描器.Peeping Tom可大致揭露测试目标的网络构造.在此之后,我们就可以进行Web应用程序扫描了.本文主要围绕Burp Suite程序讨论Web应用程序的扫描方法.确实有许多开源.免费的工具可进行Web应用程序扫描,例如ZAP.WebScarab.Nikto.w3af等程序都很不错.但是我们有必要再次强调一下,渗透测试的工具应当是速度最快.扫描结果最好的测试工具.虽然Burp Suite专业版(http://portswig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKV0dz.html" rel="bookmark">《Nmap渗透测试指南》&mdash;第9章9&period;4节审计Joomla程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				9.4 审计Joomla程序表9.5所示为本章节所需Nmap命令表,表中加粗命令为本小节所需命令--审计Joomla程序. 操作步骤使用命令&quot;nmap -p80 --script http-joomla-brute 目标&quot;即可对目标Joomla程序进行账号密码的暴力破解. root@Wing:~# nmap -p80 --script http-joomla-brute 192.168.126.131 Starting Nmap 6.40 ( http://nmap.org ) at			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1krrrz.html" rel="bookmark">《Nmap渗透测试指南》&mdash;第9章9&period;3节审计Wordpress程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				9.3 审计Wordpress程序表9.4所示为本章节所需Nmap命令表,表中加粗命令为本小节所需命令--审计Wordpress程序. 操作步骤使用命令&quot;nmap -p80 --script http-wordpress-brute 目标&quot;即可审计Wordpress密码. root@Wing:~# nmap -p80 --script http-wordpress-brute 192.168.126.131 Starting Nmap 6.40 ( http://nmap.org )			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqgJEOz.html" rel="bookmark">《编译与反编译技术》目录&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言&quot;编译原理&quot;是高等院校计算机科学与技术和软件工程专业的必修专业课之一,是一门理论与实践相结合的课程,对大学生科学思维的养成和解决实际问题能力的提高具有重要作用.&quot;编译技术&quot;是&quot;编译原理&quot;课程中介绍的关键技术,已经被广大计算机软件从业者所掌握和熟悉.&quot;反编译技术&quot;则是近几年得以迅速发展的新兴技术,许多计算机软件或信息安全从业者非常关心该项技术,但目前这方面的书籍较少,与&quot;编译技术&quot;结合起来讲解的更少.本书			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdRJ16b.html" rel="bookmark">BCB 的程序在编译环境中没事，但是运行EXE后白屏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 BCB 的程序在编译环境中没事,但是运行EXE后白屏 BCB 的程序在编译环境中没事,但是运行EXE后白屏,这是在WINXP下,在WIN2000下没有这种情况发生.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrDnvz.html" rel="bookmark" class="title">mysql出错的代码扫盲</a>
					<div>
						扫盲大讲堂:mysql出错的代码解析及解答 1005:创建表失败 1006:创建数据库失败 1007:数据库已存在,创建数据库失败 1008:数据库不存在,删除数据库失败 1009:不能删除数据库文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK6Q7z.html" rel="bookmark" class="title">&period;NET 对 J2EE&lbrack;2&rsqb;</a>
					<div>
						j2ee Picking a Winner: .NET vs. J2EE Although both frameworks stand on a foundation of programming l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVKd4b.html" rel="bookmark" class="title">SQL数据查询语句</a>
					<div>
						查询是SQL语言的核心,SQL语言只提供唯一一个用于数据库查询的语句,即SELECT语句.用于表达SQL查询的SELECT语句是功能最强也是最复杂的SQL语句,它提供了很多选项和使用方法.SELECT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE7e7b.html" rel="bookmark" class="title">voip技术与应用疑难问题分析</a>
					<div>
						对于VoIP技术,有许多爱,也有许多恨.下面是收集到的在过去的几年里有关VoIP的应用和报道中的六个&quot;疑难问题&quot;,也可以作为不使用VoIP的六个理由.这些问题没有一个能够让你从业务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrvglp.html" rel="bookmark" class="title">C&plus;&plus;语言基础-if语句</a>
					<div>
						if语句用于测试条件并在条件为真时执行一桌或几条语句. 说明:if表达式后面不能带分号,否则它本身表示代码中的空语句,使编译器将空语句解释为在条件为真时执行的语句. if (x == 10); //  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY20nZp.html" rel="bookmark" class="title">Linux下vi的用法</a>
					<div>
						一.基本命令介绍 ---- 1．光标命令 k.j.h.l--上.下.左.右光标移动命令.虽然您可以在linux中使用键盘右边的4个光标键,但是记住这4个命令还是非常有用的.这4个键正是右手在键盘上放置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w6aqp.html" rel="bookmark" class="title">Android开发入门（五）屏幕组件 5&period;3 AbsoluteLayout绝对布局</a>
					<div>
						使用AbsoluteLayout,可以指定它其中的子View的确切位置.观察如下main.xml中的代码: &lt;?xml version=&quot;1.0&quot; encoding=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yakvz.html" rel="bookmark" class="title">PowerPoint如何实现幻灯片自动循环播放</a>
					<div>
						大家在运用Microsoft PowerPoint制作课件或者展示幻灯片的时候,都会遇到这样的情况:在播放幻灯片的时候,希望实现幻灯片在不用人为干预的情况下,幻灯片播放到结尾 以后,自动回到开头,开始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRww8dp.html" rel="bookmark" class="title">PHP扩展模块Pecl、Pear以及Perl的区别</a>
					<div>
						这篇文章主要介绍了PHP扩展模块Pecl.Pear以及Perl的区别,需要的朋友可以参考下 一.简短总结: pear:一个书写的比较规范,国外较流行的工具箱代码集 pecl:php扩展包,但不属于ph ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oQnAb.html" rel="bookmark" class="title">怎么给word文档进行加密设置</a>
					<div>
						  很多人在使用Office2010写一些重要的Word文档的时候会要给文档加密,只要在Office2010上面设置密码后就可以给文件加密了哦,下面就和小编一起来看看具体怎么操作吧. Office20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGxWAp.html" rel="bookmark" class="title">Win7硬盘图标出现异常的处理方法</a>
					<div>
						  打开桌面上的&quot;计算机&quot;,在左侧菜单栏中选择&quot;组织&quot;--&quot;文件夹和搜索选项&quot;,如图所示: 在弹出的文件夹选项界面中,点击&quot;查看& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGlwdp.html" rel="bookmark" class="title">锂电池技术发展缓慢原因分析</a>
					<div>
						  对手机.平板电脑用户来说,最大的烦恼除了不能上网外,恐怕就是电量不够用,充电时间又太长了吧! 在过去近七年间,手机完成了从功能机到智能机的蜕变,手机在生活中的作用正变得越来越重要.不过,手机的发展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw89Vb.html" rel="bookmark" class="title">WinXp系统中有哪些特殊文件夹？</a>
					<div>
						  1.休眠文件夹(hiberfil.sys) hiberfil.sy文件夹是系统盘中的休眠文件,当用户启用了休眠功能后产生,休眠时电脑将内存中的数据保存在硬盘上,可恢复到之前的状态.当用户取消休眠后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQXGLp.html" rel="bookmark" class="title">大数据热潮的分析与审视</a>
					<div>
						一.大数据的历史溯源 大数据热潮方兴未艾,但若要探究何谓大数据的问题以及大数据现象何以如此兴盛的原因,我们的眼光就不仅仅只停留在它时下的具体表征上,还要对产生它的理论根源做深入分析.大数据,冠之大于数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXw1GjM.html" rel="bookmark" class="title">Windows Shellcode学习笔记&mdash;&mdash;通过VirtualProtect绕过DEP</a>
					<div>
						本文讲的是Windows Shellcode学习笔记--通过VirtualProtect绕过DEP, 0x00 前言 在掌握了栈溢出的基本原理和利用方法后,接下来就要研究如何绕过Windows系统对栈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPdeDp.html" rel="bookmark" class="title">对号入座：看看是不是已经必须离开&hellip;</a>
					<div>
						任何公司都不能工作一辈子,任何公司不能养你一辈子. 在一个公司工作是相对的,离开是绝对的. 什么时候应该离开?查查看,如果不想在公司破产后无奈的放弃应得的工资,就在它没有破产的时候,聪明的选择离开.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAyl6M.html" rel="bookmark" class="title">服务器-使用proxool连接池，cpu占用率很高</a>
					<div>
						问题描述 使用proxool连接池,cpu占用率很高 给别人用springmvc 做的一个网站,数据库用的proxool配的连接池,服务器用的tomcat.但是启动后cpu占用率一下就上去了,阿里云的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW7D0p.html" rel="bookmark" class="title">求一个会员服务的设计思路</a>
					<div>
						问题描述 最近搞一个站点,有会员服务的概念,对这个设计有些纠结.会员服务多种多样,每种服务的属性也各不相同.比如有些服务是根据时间来判断过期的,有些服务是根据个数来判断还能不能用的,买了这个服务就给次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW9d4p.html" rel="bookmark" class="title">Visual Studio 实用扩展推荐</a>
					<div>
						原文:Visual Studio 实用扩展推荐 Visual Studio 拥有非常不错的可扩展性,在之前的文章中,我也给大家示范了如何进行编辑器的扩展(详见文末参考资源).在本篇文章中,我将介绍几款 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z8dBz.html" rel="bookmark" class="title">三层结构缺少引用？</a>
					<div>
						问题描述 CS0246:找不到类型或命名空间名称&quot;ceshi&quot;(是否缺少using指令或程序集引用?)源错误:行12:usingSystem.Data.SqlTypes;行13:u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZoDgM.html" rel="bookmark" class="title">大话消息队列的流派之争</a>
					<div>
						这篇文章的标题很难起,网上一翻全是各种MQ的性能比较,很容易让人以为我也是这么&quot;粗俗&quot;的人.我这篇文章想要表达的是--它们根本不是一个东西,有毛的性能好比较?   MQ是什么?   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YDA9z.html" rel="bookmark" class="title">使用开源软件前应该问的七个问题</a>
					<div>
						现实中,我们的很多项目都是建立在开源框架上的,但是你有问过么:利用这些开源项目来赚取利润之前真的有得到过授权许可吗?或许下面的这些问题能帮助你找到答案. 不管你是不是已经开始了一个开源项目,还是决定参 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodNgvM.html" rel="bookmark" class="title">java代码-利用反编译工具出现的问题</a>
					<div>
						问题描述 利用反编译工具出现的问题 我用反编译工具将.class文件编译成.java文件后,用cmd再次编译.java文件总是会出现找不到符号的问题,不知道如何解决,请教各位大神帮我解决一下.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnRyPM.html" rel="bookmark" class="title">hadoop2容器管理错误，请高手指导</a>
					<div>
						问题描述 hadoop2容器管理错误,请高手指导 Container complete event for unknown container id 解决方案 Container complete e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2w1xM.html" rel="bookmark" class="title">网店实名制 监管成本谁买单</a>
					<div>
						争议良久的&quot;网店实名制&quot;规定终于要于7月1日正式推出了.根据国家工商总局正式出台的&lt;网络商品交易及有关服务行为管理暂行办法&gt;,网上开店&quot;实 名制&quot;原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWmJdz.html" rel="bookmark" class="title">手机搜狗输入法表情在哪里发 搜狗输入法发表情方法</a>
					<div>
						1.我们在手机中打开 手机搜狗输入法下,之后我们找到下面的[表情]标志 2.之后我们点击 emoji表情,之后我们就可以即可使用 3.好了你会看到有一个[QQ]点击它我们就可以实现 同步QQ上的表情  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0D11z.html" rel="bookmark" class="title">jQuery&plus;ajax实现鼠标单击修改内容的思路&lowbar;jquery</a>
					<div>
						现有表格中的一行的代码如下所示: 效果可以看下具体51搜索展示http://www.51bt.cc,结合Xunsearch全文检索技术,可以达到毫秒级的数据搜索 &lt;tr&gt; &lt;td&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNaErp.html" rel="bookmark" class="title">教你怎样成为百度搜索的第一&lowbar;网站应用</a>
					<div>
						百度排名NO.1在SEO(Search Engine Optimization)中其实也不算什么,此处笔者仅仅是为了通过百度排名第一位来说明SEO的相对通用的方法.当搜索引擎优化从一个鲜为人知的词语, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKAElM.html" rel="bookmark" class="title">Yii中CDbCriteria常用注释讲解教程</a>
					<div>
						$criteria =newCDbCriteria; $criteria-&gt;addCondition(&quot;id=1&quot;); //查询条件,即where id =1 $criter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N1dJz.html" rel="bookmark" class="title">GridView1&lowbar;RowDeleting 如何写点击一行删除一行</a>
					<div>
						问题描述 解决方案 解决方案二:来个大神帮帮忙解决方案三:在线等~~~~~~~~~~~~~~~~~~~~~~解决方案四:自己顶!!!!!!!!!!!!!!解决方案五:有个属性可以选定一行,然后就可以删 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
